; Initializations for sml-mode                          H.Leiss 11/98

; Under Unix, it should be invoked from your .emacs file by:
; (load-library "/usr/local/lib/emacs/site-lisp/sml-mode-3.1/sml-init") 

; -------------------------- sml-mode --------------------------------

;; Autoload sml-mode.el for editing SML-code:

(autoload 'sml-mode "sml-mode" 
  "Major mode for editing SML-NJ programs." t)

; Files ending in ".sig", ".sml", ".ml", or ".ML" are SML source or source 
; for the compilation manager of SML/NJ, so put their buffers in sml-mode. 
; (This overwrites "mocklisp" mode for "ml".)

(setq auto-mode-alist
      (append '(("\\.cm$" . sml-mode) 
		("\\.sig$" . sml-mode) 
		("\\.sml$" . sml-mode) 
		("\\.ml$"  . sml-mode)
		("\\.ML$"  . sml-mode)) auto-mode-alist))

(setq sml-mode-hook
      '(lambda() "ML mode hacks"
         (setq sml-hilite nil             ; highlight keywords (colour)
;              sml-indent-level 2         ; conserve on horiz. space
	       sml-nj-info-node "/usr/local/info/sml.info" ; sml-90!
               indent-tabs-mode nil)))    ; whatever

; ----------------------- inferior sml-mode ------------------------

;; Inferior-sml-mode is for interacting with an ML process run under
;; emacs, using the comint package. Interaction is achieved by M-x sml.

(autoload 'sml "sml-proc" "Run an inferior ML process." t) 
(autoload 'run-sml "sml-proc" "Run an inferior ML process." t) 

;; The variable sml-program-name governs which process is used, by
;; default it is just "sml". At CIS, it is the SML/NJ-110.0-compiler
;; with compilation manager [CM]. Extension by polymorphic recursion 
;; via C-u M-x run-sml, options sml-pr, sml-cm-pr.

; On Sun's, link /usr/local/bin/sml-90 to: 
; (setq sml-90 "/usr/local/pkg/leiss/sml-93-poly/src/polyrec_sml")

; Commands /usr/local/bin/sml-... are linked to the binaries in:
; (defvar sml-97-bin-path "/usr/local/pkg/leiss/sml-97/bin/")
; (defvar sml-93-bin-path "/usr/local/pkg/leiss/sml-93-poly/src/")

(setq inferior-sml-mode-hook
      '(lambda() "Interaction ML mode hacks"
	 (define-key sml-mode-map "\C-c\C-f" 'sml-send-function)
	 (define-key sml-mode-map "\C-cd"    'sml-cd)
	 (setq sml-temp-threshold 512
	       comint-scroll-show-maximum-output t
	       comint-input-autoexpand nil
	       sml-nj-info-node "/usr/local/info/sml.info")))


; -------------------------- sml-debug-mode ------------------------------
;
; Initialization of ml-debug: 
;
; The following DOES NOT WORK for sml-97. It had been working for
; sml-90 using Martin Emms' adaption to comint-mode of Alan Dingle's
; debugger for shell-mode. 

; Name of the sml executable that supports debugging.
;
;(setq ml-program-name "smld")

;(setq ml-mode-hook 'ml-debug-mode)
;(setq ml-inferior-mode-hook 'ml-debug)
;
;(autoload 'ml-debug-mode "ml-debug")
;(autoload 'sml-debug-shell "sml-debug")

; sml-debug.el-2.0 already uses comint rather than shell! So Martin's 
; adaption should no longer be needed. Check it!!


